module sync_generator(clock, HSync, VSync, vga_h_sync, vga_v_sync );

	input clock;
	output HSync, VSync, vga_h_sync, vga_v_sync;

	wire [9:0] CounterX, CounterY;

	reg ResetCntX, EnableCntY, ResetCntY;
	always @(posedge clock)
	begin
		ResetCntX <= (CounterX==798);
		EnableCntY <= (CounterX==39);
		ResetCntY <= (CounterY==524);
	end

	lpm_counter CountX( .clock(clock), .q(CounterX), .sclr(ResetCntX) );
	defparam CountX.LPM_WIDTH=10;
	lpm_counter CountY( .clock(clock), .q(CounterY), .sclr(ResetCntY), .cnt_en(EnableCntY) );
	defparam CountY.LPM_WIDTH=10;
	
	reg	HS, VS, vga_HS, vga_VS, HSync, VSync;
	always @(posedge clock)
	begin
		vga_HS <= (CounterX[9:7]==0) & (CounterX[6:5]!='b11);	// (CounterX<96)
		vga_VS <= (CounterY[9:1]==0);							// (CounterY< 2)
		HS  = (CounterX==140);
		VS <= (CounterY== 24) & HS;	// 24 instead of 28 to cancel the effect of raster_display
	end

	always @(posedge clock)
	begin
		HSync <= HS;
		VSync <= VS;
	end

	assign vga_h_sync = ~vga_HS;
	assign vga_v_sync = ~vga_VS;
endmodule

